<script lang="ts">
import Vue from 'vue';
import CompetitionModal from '../competition/competition-modal.vue';

export default Vue.extend({
  name: 'StagesTable',
  components: {
    CompetitionModal,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      totalRows: 6,
      modalOpen: false,
    };
  },
  computed: {
    formattedData() {
      const formattedStages = this.data.tabs.map((stage: any) => {
        const newCompetitors = stage.competitors.map((competitor: any) => {
          return (this as any).data.competitors.find((item: any) => {
            return item.name.includes(`${competitor}`);
          });
        });
        const newItem = {
          ...stage,
          competitors: newCompetitors,
        };
        return newItem;
      });
      return formattedStages;
    },
  },
  methods: {
    setModal(value: boolean) {
      this.modalOpen = value;
    },
  },
});
</script>

<template>
  <div class="stages-table">
    <SlpRow class="stages-table__heading">
      <SlpColumn :cols="10" size="md">
        <SlpTypography tag="h1" variant="heading2-bold" class="slp-pb-32">{{
          data.headline
        }}</SlpTypography>
        <SlpTypography tag="h5" variant="heading5">{{
          data.description
        }}</SlpTypography>

        <SlpTypography
          tag="div"
          variant="body2"
          class="overview"
          v-html="$md.render(data.overview)"
        />
      </SlpColumn>
    </SlpRow>
    <div class="stages-table__table-wrapper">
      <SlpTypography tag="h4" variant="heading4-bold" class="title">{{
        data.title
      }}</SlpTypography>
      <SlpTypography class="subtitle" tag="p" variant="body2">
        {{ data.subtitle.text }}
        <a class="ranking-button" @click="setModal(true)">
          {{ data.subtitle.link }}
        </a></SlpTypography
      >
      <table class="stages-table__table">
        <thead class="stages-table__table__stages">
          <tr>
            <th v-for="(stage, stageIndex) in formattedData" :key="stageIndex">
              <div class="stages-table__table__cell stages-table__stage">
                <SlpIcon
                  :name="stage.icon.name"
                  variant="marketing"
                  size="md"
                />
                <SlpButton
                  variant="tertiary"
                  class="slp-pt-16"
                  :href="`/competition/?stage=${stage.text}`"
                >
                  <SlpTypography
                    variant="body2"
                    class="stages-table__stage-name"
                    >{{ stage.text }}</SlpTypography
                  >
                  <SlpIcon variant="product" name="chevron-lg-right" />
                </SlpButton>
              </div>
            </th>
          </tr>
        </thead>
        <tbody class="stages-table__table__body">
          <tr
            v-for="(n, index) in totalRows"
            :key="index"
            class="stages-table__competitor"
          >
            <td
              v-for="(stage, stageIndex) in formattedData"
              :key="stageIndex"
              class="stages-table__logo"
            >
              <div v-if="stage.competitors" class="stages-table__img">
                <a
                  v-if="stage.competitors[index]"
                  :class="{
                    'stages-table__img-link': stage.competitors[index].href,
                  }"
                  :href="stage.competitors[index].href"
                >
                  <nuxt-img
                    :class="`stages-table__img--${stage.competitors[index].size}`"
                    :src="stage.competitors[index].logo"
                    :alt="
                      stage.competitors[index].logo_alt
                        ? stage.competitors[index].logo_alt
                        : ''
                    "
                    loading="lazy"
                    format="webp"
                    quality="99"
                  />
                </a>
              </div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <SlpRow class="stages-table__disclaimer">
      <SlpColumn :cols="8" size="md">
        <SlpTypography tag="p" variant="body3">{{
          data.disclaimer.intro
        }}</SlpTypography>
        <SlpTypography
          tag="p"
          variant="body3"
          class="slp-pt-24 stages-table__italic"
          >{{ data.disclaimer.legend }}</SlpTypography
        >
      </SlpColumn>
    </SlpRow>
    <CompetitionModal
      v-if="modalOpen"
      :visible="modalOpen"
      :aria-modal="modalOpen"
      :aria-hidden="!modalOpen"
      light-background
      :aria-labelledby="`ranking-modal-control`"
      @close="setModal(false)"
      ><template #body>
        <div class="ranking-modal">
          <SlpTypography variant="heading5-bold" class="header">{{
            data.modal.header
          }}</SlpTypography>
          <div
            v-for="block in data.modal.blocks"
            :key="block.header"
            class="ranking-block"
          >
            <div class="left-block">
              <SlpIcon
                :name="block.icon"
                size="md"
                variant="marketing"
                class="ranking-icon"
              />
              <SlpTypography variant="body2-bold">{{
                block.name
              }}</SlpTypography>
            </div>
            <div class="right-block">
              <SlpTypography
                class="text"
                variant="body3"
                tag="div"
                v-html="$md.render(block.text)"
              />
              <SlpButton
                variant="tertiary"
                class="cta"
                data-ga-location="ranking modal"
                :data-ga-name="`ranking-modal-${block.name}`"
                :href="`/competition/?stage=${block.name}`"
                ><SlpTypography variant="body3-bold">Learn more</SlpTypography
                ><SlpIcon variant="product" name="chevron-lg-right"
              /></SlpButton>
            </div>
          </div>
        </div> </template
    ></CompetitionModal>
  </div>
</template>

<style lang="scss" scoped>
.ranking-button {
  cursor: pointer;
}
.ranking-modal {
  display: flex;
  flex-direction: column;
  .header {
    margin-bottom: 40px;
  }
  .ranking-block {
    display: flex;
    margin-bottom: 46px;
    .right-block {
      .cta {
        padding-left: 0;
      }
      .text {
        &:deep(ul) {
          padding-left: $spacing-16;
          list-style: disc;
          li {
            margin-bottom: 16px;
          }
        }
      }
    }
    .left-block {
      display: flex;
      min-width: 125px;
      margin-right: 16px;
      .ranking-icon {
        height: 18px;
        height: 18px;
      }
    }
  }
}
.overview {
  margin-top: $spacing-16;
  &:deep(p) {
    margin-bottom: $spacing-16;
  }
}
.stages-table {
  table {
    width: 100%;
    table-layout: fixed;
    min-width: $breakpoint-lg;
  }
  table,
  th,
  td {
    border-spacing: 0;
    -webkit-border-horizontal-spacing: 0;
    padding: 0;
  }
  td,
  th {
    border-left: 1px solid $color-surface-200;
    &:first-of-type {
      border-left: 0;
    }
  }
  th {
    border-bottom: 1px solid $color-surface-200;
  }
  tbody tr {
    &:first-of-type {
      .stages-table__img {
        padding-top: $spacing-48;
      }
    }
  }
  &__table-wrapper {
    .title {
      text-align: center;
      margin-bottom: 12px;
    }
    .subtitle {
      text-align: center;
      margin-bottom: $spacing-48;
    }
    overflow: scroll;
    box-shadow: 0 8px 50px -16px $color-primary-100;
    padding: $spacing-48 $spacing-0 $spacing-24;
    border-radius: 8px;
    border: 1px solid $color-surface-200;
  }

  &__stage {
    align-items: center;
    display: flex;
    flex-direction: column;
    padding: 0 0 $spacing-32;
  }
  &__img {
    display: flex;
    align-items: center;
    justify-content: center;
    padding: $spacing-24 $spacing-8;
    height: 100%;
    position: relative;

    &-link {
      transition: transform 0.3s ease;
      transform: scale(1);
      &:hover,
      &:active,
      &:focus {
        transform: scale(1.15);
      }
    }
    img {
      max-width: 80px;
      width: 100%;
    }
    &--sm {
      max-height: 25px;
    }
    &--md {
      max-height: 40px;
    }
    &--lg {
      max-height: 45px;
    }
    &--xl {
      max-height: 45px;
      max-width: 95px !important;
    }
  }

  &__logo {
    width: 50%;
    @media (min-width: $breakpoint-md) {
      width: auto;
    }
  }

  &__heading {
    padding: $spacing-32 0 $spacing-48 0;
    position: relative;
    z-index: 1000;
    @media (min-width: $breakpoint-md) {
      padding: $spacing-64 0;
    }
  }

  &__disclaimer {
    padding: $spacing-32 0 0 0;
    @media (min-width: $breakpoint-md) {
      padding: $spacing-96 0 0 0;
    }
  }

  &__italic {
    font-style: italic;
  }

  &__stage-name {
    text-transform: capitalize;
  }
}
</style>
